from browser import document, window, prompt, confirm, html
import json


def insert_this_in_that(*, this_id: str = None,
                        this_template: str = None,
                        that_id: str = None,
                        that_element=None):
    """
    inserts this.html in that
    :param this_template: element html template received from django view render function
    :param this_id: id of element who's inner html will be inserted into that_id element
    :param that_id: where this_id's inner html will be inserted
    :param that_element: Element object from the document
    :return:
    """
    if this_id:
        try:
            this = document[this_id].html
        except KeyError as e:
            # insert a false this
            this = '<div id="falseDIv"><small>Something is happening...</small></div>'
    else:
        this = this_template
    # register an element on document
    insert_this = document.createElement('div')
    insert_this.html = this

    if that_id:
        document[that_id].clear()
        document[that_id].appendChild(insert_this)
    if that_element:
        that_element.clear()
        that_element.appendChild(insert_this)
    del insert_this


class TempStorageObject:
    pass


tso = TempStorageObject()


# ---------------------- ACTIONS/EVENTS --------
def store_count_on_mobile_button_action(event):
    class_list = event.currentTarget.select('#storeCountOnMobileArrow')[0].classList
    if 'ion-arrow-up-b' in class_list:
        event.currentTarget.classList.remove('rgba-black-strong')
        event.currentTarget.classList.add('rgba-black-light')
        document['results'].classList.remove('d-none', 'fadeOutDown')
        document['results'].classList.add('fadeInUp')
        class_list.remove('ion-arrow-up-b')
        class_list.add('ion-arrow-down-b')
    else:
        event.currentTarget.classList.remove('rgba-black-light')
        event.currentTarget.classList.add('rgba-black-strong')
        document['results'].classList.remove('fadeInUp')
        document['results'].classList.add('fadeOutDown', 'd-none')
        class_list.remove('ion-arrow-down-b')
        class_list.add('ion-arrow-up-b')



# -------------- EVENT BINDINGS ---------
# bind events ['click', 'on hover' ect.] on different divs and buttons
def bind_click_on_store_count_on_mobile_button(unbind=False):
    try:
        button = document['storeCountOnMobile']
        if not unbind:
            button.bind("click", store_count_on_mobile_button_action)
        else:
            button.unbind("click", store_count_on_mobile_button_action)
    except Exception as e:
        pass


bind_click_on_store_count_on_mobile_button()
